from enum import Enum
from ...types import MCEnum, UnsignedByte, Byte, String, SafeBuff

class Material(Enum):
    AIR = 0
    STONE = 1
    GRASS = 2
    DIRT = 3
    COBBLESTONE = 4
    OAK_WOOD_PLANK = 5
    OAK_SAPLING = 6
    BEDROCK = 7
    FLOWING_WATER = 8
    STILL_WATER = 9
    FLOWING_LAVA = 10
    STILL_LAVA = 11
    SAND = 12
    GRAVEL = 13
    GOLD_ORE = 14
    IRON_ORE = 15
    COAL_ORE = 16
    OAK_WOOD = 17
    OAK_LEAVES = 18
    SPONGE = 19
    GLASS = 20
    LAPIS_LAZULI_ORE = 21
    LAPIS_LAZULI_BLOCK = 22
    DISPENSER = 23
    SANDSTONE = 24
    NOTE_BLOCK = 25
    BED = 26
    POWERED_RAIL = 27
    DETECTOR_RAIL = 28
    STICKY_PISTON = 29
    COBWEB = 30
    DEAD_SHRUB = 31
    DEAD_BUSH = 32
    PISTON = 33
    PISTON_HEAD = 34
    WHITE_WOOL = 35
    DANDELION = 37
    POPPY = 38
    BROWN_MUSHROOM = 39
    RED_MUSHROOM = 40
    GOLD_BLOCK = 41
    IRON_BLOCK = 42
    DOUBLE_STONE_SLAB = 43
    STONE_SLAB = 44
    BRICKS = 45
    TNT = 46
    BOOKSHELF = 47
    MOSS_STONE = 48
    OBSIDIAN = 49
    TORCH = 50
    FIRE = 51
    MONSTER_SPAWNER = 52
    OAK_WOOD_STAIRS = 53
    CHEST = 54
    REDSTONE_WIRE = 55
    DIAMOND_ORE = 56
    DIAMOND_BLOCK = 57
    CRAFTING_TABLE = 58
    WHEAT_CROPS = 59
    FARMLAND = 60
    FURNACE = 61
    BURNING_FURNACE = 62
    STANDING_SIGN_BLOCK = 63
    OAK_DOOR_BLOCK = 64
    LADDER = 65
    RAIL = 66
    COBBLESTONE_STAIRS = 67
    WALL_MOUNTED_SIGN_BLOCK = 68
    LEVER = 69
    STONE_PRESSURE_PLATE = 70
    IRON_DOOR_BLOCK = 71
    WOODEN_PRESSURE_PLATE = 72
    REDSTONE_ORE = 73
    GLOWING_REDSTONE_ORE = 74
    REDSTONE_TORCH_OFF = 75
    REDSTONE_TORCH_ON = 76
    STONE_BUTTON = 77
    SNOW = 78
    ICE = 79
    SNOW_BLOCK = 80
    CACTUS = 81
    CLAY = 82
    SUGAR_CANES = 83
    JUKEBOX = 84
    OAK_FENCE = 85
    PUMPKIN = 86
    NETHERRACK = 87
    SOUL_SAND = 88
    GLOWSTONE = 89
    NETHER_PORTAL = 90
    JACK_O_LANTERN = 91
    CAKE_BLOCK = 92
    REDSTONE_REPEATER_BLOCK_OFF = 93
    REDSTONE_REPEATER_BLOCK_ON = 94
    WHITE_STAINED_GLASS = 95
    WOODEN_TRAPDOOR = 96
    STONE_MONSTER_EGG = 97
    STONE_BRICKS = 98
    BROWN_MUSHROOM_BLOCK = 99
    RED_MUSHROOM_BLOCK = 100
    IRON_BARS = 101
    GLASS_PANE = 102
    MELON_BLOCK = 103
    PUMPKIN_STEM = 104
    MELON_STEM = 105
    VINES = 106
    OAK_FENCE_GATE = 107
    BRICK_STAIRS = 108
    STONE_BRICK_STAIRS = 109
    MYCELIUM = 110
    LILY_PAD = 111
    NETHER_BRICK = 112
    NETHER_BRICK_FENCE = 113
    NETHER_BRICK_STAIRS = 114
    NETHER_WART = 115
    ENCHANTMENT_TABLE = 116
    BREWING_STAND = 117
    CAULDRON = 118
    END_PORTAL = 119
    END_PORTAL_FRAME = 120
    END_STONE = 121
    DRAGON_EGG = 122
    REDSTONE_LAMP_INACTIVE = 123
    REDSTONE_LAMP_ACTIVE = 124
    DOUBLE_OAK_WOOD_SLAB = 125
    OAK_WOOD_SLAB = 126
    COCOA = 127
    SANDSTONE_STAIRS = 128
    EMERALD_ORE = 129
    ENDER_CHEST = 130
    TRIPWIRE_HOOK = 131
    TRIPWIRE = 132
    EMERALD_BLOCK = 133
    SPRUCE_WOOD_STAIRS = 134
    BIRCH_WOOD_STAIRS = 135
    JUNGLE_WOOD_STAIRS = 136
    COMMAND_BLOCK = 137
    BEACON = 138
    COBBLESTONE_WALL = 139
    FLOWER_POT = 140
    CARROTS = 141
    POTATOES = 142
    WOODEN_BUTTON = 143
    MOB_HEAD = 144
    ANVIL = 145
    TRAPPED_CHEST = 146
    WEIGHTED_PRESSURE_PLATE_LIGHT = 147
    WEIGHTED_PRESSURE_PLATE_HEAVY = 148
    REDSTONE_COMPARATOR_INACTIVE = 149
    REDSTONE_COMPARATOR_ACTIVE = 150
    DAYLIGHT_SENSOR = 151
    REDSTONE_BLOCK = 152
    NETHER_QUARTZ_ORE = 153
    HOPPER = 154
    QUARTZ_BLOCK = 155
    QUARTZ_STAIRS = 156
    ACTIVATOR_RAIL = 157
    DROPPER = 158
    WHITE_HARDENED_CLAY = 159
    WHITE_STAINED_GLASS_PANE = 160
    ACACIA_LEAVES = 161
    ACACIA_WOOD = 162
    ACACIA_WOOD_STAIRS = 163
    DARK_OAK_WOOD_STAIRS = 164
    SLIME_BLOCK = 165
    BARRIER = 166
    IRON_TRAPDOOR = 167
    PRISMARINE = 168
    SEA_LANTERN = 169
    HAY_BALE = 170
    WHITE_CARPET = 171
    HARDENED_CLAY = 172
    BLOCK_OF_COAL = 173
    PACKED_ICE = 174
    SUNFLOWER = 175
    FREE_STANDING_BANNER = 176
    WALL_MOUNTED_BANNER = 177
    INVERTED_DAYLIGHT_SENSOR = 178
    RED_SANDSTONE = 179
    RED_SANDSTONE_STAIRS = 180
    DOUBLE_RED_SANDSTONE_SLAB = 181
    RED_SANDSTONE_SLAB = 182
    SPRUCE_FENCE_GATE = 183
    BIRCH_FENCE_GATE = 184
    JUNGLE_FENCE_GATE = 185
    DARK_OAK_FENCE_GATE = 186
    ACACIA_FENCE_GATE = 187
    SPRUCE_FENCE = 188
    BIRCH_FENCE = 189
    JUNGLE_FENCE = 190
    DARK_OAK_FENCE = 191
    ACACIA_FENCE = 192
    SPRUCE_DOOR_BLOCK = 193
    BIRCH_DOOR_BLOCK = 194
    JUNGLE_DOOR_BLOCK = 195
    ACACIA_DOOR_BLOCK = 196
    DARK_OAK_DOOR_BLOCK = 197
    END_ROD = 198
    CHORUS_PLANT = 199
    CHORUS_FLOWER = 200
    PURPUR_BLOCK = 201
    PURPUR_PILLAR = 202
    PURPUR_STAIRS = 203
    PURPUR_DOUBLE_SLAB = 204
    PURPUR_SLAB = 205
    END_STONE_BRICKS = 206
    BEETROOT_BLOCK = 207
    GRASS_PATH = 208
    END_GATEWAY = 209
    REPEATING_COMMAND_BLOCK = 210
    CHAIN_COMMAND_BLOCK = 211
    FROSTED_ICE = 212
    MAGMA_BLOCK = 213
    NETHER_WART_BLOCK = 214
    RED_NETHER_BRICK = 215
    BONE_BLOCK = 216
    STRUCTURE_VOID = 217
    OBSERVER = 218
    WHITE_SHULKER_BOX = 219
    ORANGE_SHULKER_BOX = 220
    MAGENTA_SHULKER_BOX = 221
    LIGHT_BLUE_SHULKER_BOX = 222
    YELLOW_SHULKER_BOX = 223
    LIME_SHULKER_BOX = 224
    PINK_SHULKER_BOX = 225
    GRAY_SHULKER_BOX = 226
    LIGHT_GRAY_SHULKER_BOX = 227
    CYAN_SHULKER_BOX = 228
    PURPLE_SHULKER_BOX = 229
    BLUE_SHULKER_BOX = 230
    BROWN_SHULKER_BOX = 231
    GREEN_SHULKER_BOX = 232
    RED_SHULKER_BOX = 233
    BLACK_SHULKER_BOX = 234
    WHITE_GLAZED_TERRACOTTA = 235
    ORANGE_GLAZED_TERRACOTTA = 236
    MAGENTA_GLAZED_TERRACOTTA = 237
    LIGHT_BLUE_GLAZED_TERRACOTTA = 238
    YELLOW_GLAZED_TERRACOTTA = 239
    LIME_GLAZED_TERRACOTTA = 240
    PINK_GLAZED_TERRACOTTA = 241
    GRAY_GLAZED_TERRACOTTA = 242
    LIGHT_GRAY_GLAZED_TERRACOTTA = 243
    CYAN_GLAZED_TERRACOTTA = 244
    PURPLE_GLAZED_TERRACOTTA = 245
    BLUE_GLAZED_TERRACOTTA = 246
    BROWN_GLAZED_TERRACOTTA = 247
    GREEN_GLAZED_TERRACOTTA = 248
    RED_GLAZED_TERRACOTTA = 249
    BLACK_GLAZED_TERRACOTTA = 250
    WHITE_CONCRETE = 251
    WHITE_CONCRETE_POWDER = 252
    STRUCTURE_BLOCK = 255
    IRON_SHOVEL = 256
    IRON_PICKAXE = 257
    IRON_AXE = 258
    FLINT_AND_STEEL = 259
    APPLE = 260
    BOW = 261
    ARROW = 262
    COAL = 263
    DIAMOND = 264
    IRON_INGOT = 265
    GOLD_INGOT = 266
    IRON_SWORD = 267
    WOODEN_SWORD = 268
    WOODEN_SHOVEL = 269
    WOODEN_PICKAXE = 270
    WOODEN_AXE = 271
    STONE_SWORD = 272
    STONE_SHOVEL = 273
    STONE_PICKAXE = 274
    STONE_AXE = 275
    DIAMOND_SWORD = 276
    DIAMOND_SHOVEL = 277
    DIAMOND_PICKAXE = 278
    DIAMOND_AXE = 279
    STICK = 280
    BOWL = 281
    MUSHROOM_STEW = 282
    GOLDEN_SWORD = 283
    GOLDEN_SHOVEL = 284
    GOLDEN_PICKAXE = 285
    GOLDEN_AXE = 286
    STRING = 287
    FEATHER = 288
    GUNPOWDER = 289
    WOODEN_HOE = 290
    STONE_HOE = 291
    IRON_HOE = 292
    DIAMOND_HOE = 293
    GOLDEN_HOE = 294
    WHEAT_SEEDS = 295
    WHEAT = 296
    BREAD = 297
    LEATHER_HELMET = 298
    LEATHER_TUNIC = 299
    LEATHER_PANTS = 300
    LEATHER_BOOTS = 301
    CHAINMAIL_HELMET = 302
    CHAINMAIL_CHESTPLATE = 303
    CHAINMAIL_LEGGINGS = 304
    CHAINMAIL_BOOTS = 305
    IRON_HELMET = 306
    IRON_CHESTPLATE = 307
    IRON_LEGGINGS = 308
    IRON_BOOTS = 309
    DIAMOND_HELMET = 310
    DIAMOND_CHESTPLATE = 311
    DIAMOND_LEGGINGS = 312
    DIAMOND_BOOTS = 313
    GOLDEN_HELMET = 314
    GOLDEN_CHESTPLATE = 315
    GOLDEN_LEGGINGS = 316
    GOLDEN_BOOTS = 317
    FLINT = 318
    RAW_PORKCHOP = 319
    COOKED_PORKCHOP = 320
    PAINTING = 321
    GOLDEN_APPLE = 322
    SIGN = 323
    OAK_DOOR = 324
    BUCKET = 325
    WATER_BUCKET = 326
    LAVA_BUCKET = 327
    MINECART = 328
    SADDLE = 329
    IRON_DOOR = 330
    REDSTONE = 331
    SNOWBALL = 332
    OAK_BOAT = 333
    LEATHER = 334
    MILK_BUCKET = 335
    BRICK = 336
    OTHER_CLAY = 337
    OTHER_SUGAR_CANES = 338
    PAPER = 339
    BOOK = 340
    SLIMEBALL = 341
    MINECART_WITH_CHEST = 342
    MINECART_WITH_FURNACE = 343
    EGG = 344
    COMPASS = 345
    FISHING_ROD = 346
    CLOCK = 347
    GLOWSTONE_DUST = 348
    RAW_FISH = 349
    COOKED_FISH = 350
    INK_SACK = 351
    BONE = 352
    SUGAR = 353
    CAKE = 354
    OTHER_BED = 355
    REDSTONE_REPEATER = 356
    COOKIE = 357
    MAP = 358
    SHEARS = 359
    MELON = 360
    PUMPKIN_SEEDS = 361
    MELON_SEEDS = 362
    RAW_BEEF = 363
    STEAK = 364
    RAW_CHICKEN = 365
    COOKED_CHICKEN = 366
    ROTTEN_FLESH = 367
    ENDER_PEARL = 368
    BLAZE_ROD = 369
    GHAST_TEAR = 370
    GOLD_NUGGET = 371
    OTHER_NETHER_WART = 372
    POTION = 373
    GLASS_BOTTLE = 374
    SPIDER_EYE = 375
    FERMENTED_SPIDER_EYE = 376
    BLAZE_POWDER = 377
    MAGMA_CREAM = 378
    OTHER_BREWING_STAND = 379
    OTHER_CAULDRON = 380
    EYE_OF_ENDER = 381
    GLISTERING_MELON = 382
    BOTTLE_O_ENCHANTING = 384
    FIRE_CHARGE = 385
    BOOK_AND_QUILL = 386
    WRITTEN_BOOK = 387
    EMERALD = 388
    ITEM_FRAME = 389
    OTHER_FLOWER_POT = 390
    CARROT = 391
    POTATO = 392
    BAKED_POTATO = 393
    POISONOUS_POTATO = 394
    EMPTY_MAP = 395
    GOLDEN_CARROT = 396
    MOB_HEAD_SKELETON = 397
    CARROT_ON_A_STICK = 398
    NETHER_STAR = 399
    PUMPKIN_PIE = 400
    FIREWORK_ROCKET = 401
    FIREWORK_STAR = 402
    ENCHANTED_BOOK = 403
    REDSTONE_COMPARATOR = 404
    OTHER_NETHER_BRICK = 405
    NETHER_QUARTZ = 406
    MINECART_WITH_TNT = 407
    MINECART_WITH_HOPPER = 408
    PRISMARINE_SHARD = 409
    PRISMARINE_CRYSTALS = 410
    RAW_RABBIT = 411
    COOKED_RABBIT = 412
    RABBIT_STEW = 413
    RABBITS_FOOT = 414
    RABBIT_HIDE = 415
    ARMOR_STAND = 416
    IRON_HORSE_ARMOR = 417
    GOLDEN_HORSE_ARMOR = 418
    DIAMOND_HORSE_ARMOR = 419
    LEAD = 420
    NAME_TAG = 421
    MINECART_WITH_COMMAND_BLOCK = 422
    RAW_MUTTON = 423
    COOKED_MUTTON = 424
    BANNER = 425
    END_CRYSTAL = 426
    SPRUCE_DOOR = 427
    BIRCH_DOOR = 428
    JUNGLE_DOOR = 429
    ACACIA_DOOR = 430
    DARK_OAK_DOOR = 431
    CHORUS_FRUIT = 432
    POPPED_CHORUS_FRUIT = 433
    BEETROOT = 434
    BEETROOT_SEEDS = 435
    BEETROOT_SOUP = 436
    DRAGONS_BREATH = 437
    SPLASH_POTION = 438
    SPECTRAL_ARROW = 439
    TIPPED_ARROW = 440
    LINGERING_POTION = 441
    SHIELD = 442
    ELYTRA = 443
    SPRUCE_BOAT = 444
    BIRCH_BOAT = 445
    JUNGLE_BOAT = 446
    ACACIA_BOAT = 447
    DARK_OAK_BOAT = 448
    TOTEM_OF_UNDYING = 449
    SHULKER_SHELL = 450
    IRON_NUGGET = 452
    KNOWLEDGE_BOOK = 453
    _13_DISC = 2256
    CAT_DISC = 2257
    BLOCKS_DISC = 2258
    CHIRP_DISC = 2259
    FAR_DISC = 2260
    MALL_DISC = 2261
    MELLOHI_DISC = 2262
    STAL_DISC = 2263
    STRAD_DISC = 2264
    WARD_DISC = 2265
    _11_DISC = 2266
    WAIT_DISC = 2267

    def __repr__(self) -> str:
        return f'<{self.value}: {self.name} v47>'

class Mob(MCEnum):

    IntegerType: UnsignedByte

    MOB = 48
    MONSTER = 49
    CREEPER = 50
    SKELETON = 51
    SPIDER = 52
    GIANT_ZOMBIE = 53
    ZOMBIE = 54
    SLIME = 55
    GHAST = 56
    ZOMBIE_PIGMAN = 57
    ENDERMAN = 58
    CAVE_SPIDER = 59
    SILVERFISH = 60
    BLAZE = 61
    MAGMA_CUBE = 62
    ENDER_DRAGON = 63
    WITHER = 64
    BAT = 65
    WITCH = 66
    ENDERMITE = 67
    GUARDIAN = 68
    SHULKER = 69
    PIG = 90
    SHEEP = 91
    COW = 92
    CHICKEN = 93
    SQUID = 94
    WOLF = 95
    MOOSHROOM = 96
    SNOWMAN = 97
    OCELOT = 98
    IRON_GOLEM = 99
    HORSE = 100
    RABBIT = 101
    VILLAGER = 120

class Object(MCEnum):

    IntegerType: Byte

    BOAT = 1
    ITEM_STACK = 2 # (SLOT)
    AREA_EFFECT_CLOUD = 3
    MINECART = 10
    MINECART_STORAGE = 11 # (unused since 1.6.x)
    MINECART_POWERED = 12 # (unused since 1.6.x)
    ACTIVATED_TNT = 50
    ENDERCRYSTAL = 51
    ARROW = 60 # (PROJECTILE)
    SNOWBALL = 61 # (PROJECTILE)
    EGG = 62 # (PROJECTILE)
    FIREBALL = 63 # (GHAST PROJECTILE)
    FIRECHARGE = 64 # (BLAZE PROJECTILE)
    THROWN_ENDERPEARL = 65
    WITHER_SKULL = 66 # (PROJECTILE)
    SHULKER_BULLET = 67
    FALLING_OBJECT = 70
    ITEM_FRAME = 71
    EYE_OF_ENDER = 72
    THROWN_POTION = 73
    FALLING_DRAGON_EGG = 74
    THROWN_EXP_BOTTLE = 75
    FIREWORK_ROCKET = 76
    LEASH_KNOT = 77
    ARMORSTAND = 78
    FISHING_FLOAT = 90
    SPECTRAL_ARROW = 91
    TIPPED_ARROW = 92
    DRAGON_FIREBALL = 93

class Sound(Enum):

    def to_id(self) -> str:
        return self.name.lower().replace("_", ".")
    
    @classmethod
    def from_id(cls, id: str) -> None:
        return getattr(cls, id.upper().replace(".", "_"))
    
    def build(self) -> bytes:
        return String.build(self.to_id())
    
    @classmethod
    def destroy(cls, buff: SafeBuff) -> None:
        id_ = String.destroy(buff)
        return cls.from_id(id_)

    AMBIENT_CAVE_CAVE = 0
    AMBIENT_WEATHER_RAIN = 1
    AMBIENT_WEATHER_THUNDER = 2
    DAMAGE_FALLBIG = 3
    DAMAGE_FALLSMALL = 4
    FIRE_FIRE = 5
    FIRE_IGNITE = 6
    LIQUID_LAVA = 7
    LIQUID_LAVAPOP = 8
    LIQUID_SPLASH = 9
    LIQUID_WATER = 10
    MOB_BLAZE_BREATHE = 11
    MOB_BLAZE_DEATH = 12
    MOB_BLAZE_HIT = 13
    MOB_CAT_HISS = 14
    MOB_CAT_HITT = 15
    MOB_CAT_MEOW = 16
    MOB_CAT_PURR = 17
    MOB_CAT_PURREOW = 18
    MOB_CHICKEN_HURT = 19
    MOB_CHICKEN_PLOP = 20
    MOB_COW_HURT = 21
    MOB_CREEPER = 22
    MOB_CREEPERDEATH = 23
    MOB_ENDERMEN_DEATH = 24
    MOB_ENDERMEN_HIT = 25
    MOB_ENDERMEN_IDLE = 26
    MOB_ENDERMEN_PORTAL = 27
    MOB_ENDERMEN_SCREAM = 28
    MOB_ENDERMEN_STARE = 29
    MOB_GHAST_AFFECTIONATESCREAM = 30
    MOB_GHAST_CHARGE = 31
    MOB_GHAST_DEATH = 32
    MOB_GHAST_FIREBALL = 33
    MOB_GHAST_MOAN = 34
    MOB_GHAST_SCREAM = 35
    MOB_IRONGOLEM_DEATH = 36
    MOB_IRONGOLEM_HIT = 37
    MOB_IRONGOLEM_THROW = 38
    MOB_IRONGOLEM_WALK = 39
    MOB_MAGMACUBE_BIG = 40
    MOB_MAGMACUBE_JUMP = 41
    MOB_MAGMACUBE_SMALL = 42
    MOB_PIG_DEATH = 43
    MOB_SILVERFISH_HIT = 44
    MOB_SILVERFISH_KILL = 45
    MOB_SILVERFISH_SAY = 46
    MOB_SILVERFISH_STEP = 47
    MOB_SKELETON_DEATH = 48
    MOB_SKELETON_HURT = 49
    MOB_SLIME_ATTACK = 50
    MOB_SPIDER_DEATH = 51
    MOB_WOLF_BARK = 52
    MOB_WOLF_DEATH = 53
    MOB_WOLF_GROWL = 54
    MOB_WOLF_HOWL = 55
    MOB_WOLF_HURT = 56
    MOB_WOLF_PANTING = 57
    MOB_WOLF_SHAKE = 58
    MOB_WOLF_WHINE = 59
    MOB_ZOMBIE_METAL = 60
    MOB_ZOMBIE_WOOD = 61
    MOB_ZOMBIE_WOODBREAK = 62
    MOB_ZOMBIE = 63
    MOB_ZOMBIE_DEATH = 64
    MOB_ZOMBIE_HURT = 65
    MOB_ZOMBIEPIG_ZPIG = 66
    MOB_ZOMBIEPIG_ZPIGANGRY = 67
    MOB_ZOMBIEPIG_ZPIGDEATH = 68
    MOB_ZOMBIEPIG_ZPIGHURT = 69
    NOTE_BASS = 70
    NOTE_BASSATTACK = 71
    NOTE_BD = 72
    NOTE_HARP = 73
    NOTE_HAT = 74
    NOTE_PLING = 75
    NOTE_SNARE = 76
    PORTAL_PORTAL = 77
    PORTAL_TRAVEL = 78
    PORTAL_TRIGGER = 79
    RANDOM_BOW = 80
    RANDOM_BOWHIT = 81
    RANDOM_BREAK = 82
    RANDOM_BREATH = 83
    RANDOM_BURP = 84
    RANDOM_CHESTCLOSED = 85
    RANDOM_CHESTOPEN = 86
    RANDOM_CLICK = 87
    RANDOM_DOOR_CLOSE = 88
    RANDOM_DOOR_OPEN = 89
    RANDOM_DRINK = 90
    RANDOM_EAT = 91
    RANDOM_EXPLODE = 92
    RANDOM_FIZZ = 93
    RANDOM_FUSE = 94
    RANDOM_GLASS = 95
    RANDOM_LEVELUP = 96
    RANDOM_OLD_EXPLODE = 97
    RANDOM_ORB = 98
    RANDOM_POP = 99
    RANDOM_SPLASH = 100
    RANDOM_WOODCLICK = 101
    STEP_CLOTH = 102
    STEP_GRASS = 103
    STEP_GRAVEL = 104
    STEP_SAND = 105
    STEP_SNOW = 106
    STEP_STONE = 107
    STEP_WOOD = 108
    TILE_PISTON_IN = 109
    TILE_PISTON_OUT = 110
    DAMAGE_HIT = 111
    DIG_CLOTH = 112
    DIG_GRASS = 113
    DIG_GRAVEL = 114
    DIG_SAND = 115
    DIG_SNOW = 116
    DIG_STONE = 117
    DIG_WOOD = 118
    LIQUID_SWIM = 119
    MINECART_BASE = 120
    MINECART_INSIDE = 121
    MOB_CHICKEN_SAY = 122
    MOB_CHICKEN_STEP = 123
    MOB_COW_SAY = 124
    MOB_COW_STEP = 125
    MOB_CREEPER_SAY = 126
    MOB_PIG_DEATH2 = 127
    MOB_PIG_SAY = 128
    MOB_PIG_STEP = 129
    MOB_SHEEP_SAY = 130
    MOB_SHEEP_SHEAR = 131
    MOB_SHEEP_STEP = 132
    MOB_SKELETON_SAY = 133
    MOB_SKELETON_STEP = 134
    MOB_SLIME_ATTACK2 = 135
    MOB_SLIME_BIG = 136
    MOB_SLIME_SMALL = 137
    MOB_SPIDER_SAY = 138
    MOB_SPIDER_STEP = 139
    MOB_WOLF_STEP = 140
    MOB_ZOMBIE_DEATH2 = 141
    MOB_ZOMBIE_HURT2 = 142
    MOB_ZOMBIE_SAY = 143
    MOB_ZOMBIE_STEP = 144
    RANDOM_CLASSIC_HURT = 145
    STEP_LADDER = 146
    MOB_BAT_DEATH = 147
    MOB_BAT_HURT = 148
    MOB_BAT_IDLE = 149
    MOB_BAT_TAKEOFF = 150
    MOB_ENDERDRAGON_END = 151
    MOB_ENDERDRAGON_GROWL = 152
    MOB_ENDERDRAGON_HIT = 153
    MOB_ENDERDRAGON_WINGS = 154
    MOB_WITHER_DEATH = 155
    MOB_WITHER_HURT = 156
    MOB_WITHER_IDLE = 157
    MOB_WITHER_SHOOT = 158
    MOB_WITHER_SPAWN = 159
    MOB_ZOMBIE_INFECT = 160
    MOB_ZOMBIE_REMEDY = 161
    MOB_ZOMBIE_UNFECT = 162
    RANDOM_ANVIL_BREAK = 163
    RANDOM_ANVIL_LAND = 164
    RANDOM_ANVIL_USE = 165
    GAME_NEUTRAL_SWIM_SPLASH = 166